Index: c/src/tests/samples/base_mp/apptask.c
===================================================================
--- c/src/tests/samples/base_mp/apptask.c	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/base_mp/apptask.c	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -18,5 +18,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  apptask.c,v 1.2 1995/05/31 17:05:14 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/base_mp/system.h
===================================================================
--- c/src/tests/samples/base_mp/system.h	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/base_mp/system.h	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -12,5 +12,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  system.h,v 1.2 1995/05/31 17:05:21 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/base_sp/apptask.c
===================================================================
--- c/src/tests/samples/base_sp/apptask.c	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/base_sp/apptask.c	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -17,5 +17,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  apptask.c,v 1.2 1995/05/31 17:05:28 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/cdtest/init.c
===================================================================
--- c/src/tests/samples/cdtest/init.c	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/cdtest/init.c	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -19,5 +19,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  init.c,v 1.2 1995/05/31 17:05:45 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/cdtest/system.h
===================================================================
--- c/src/tests/samples/cdtest/system.h	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/cdtest/system.h	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -12,5 +12,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  system.h,v 1.2 1995/05/31 17:05:49 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/hello/init.c
===================================================================
--- c/src/tests/samples/hello/init.c	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/hello/init.c	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -19,5 +19,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  init.c,v 1.2 1995/05/31 17:05:58 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/hello/system.h
===================================================================
--- c/src/tests/samples/hello/system.h	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/hello/system.h	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -12,5 +12,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  system.h,v 1.2 1995/05/31 17:06:00 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/paranoia/init.c
===================================================================
--- c/src/tests/samples/paranoia/init.c	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/paranoia/init.c	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -19,5 +19,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  init.c,v 1.2 1995/05/31 17:06:07 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/paranoia/paranoia.c
===================================================================
--- c/src/tests/samples/paranoia/paranoia.c	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/paranoia/paranoia.c	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -1,4 +1,4 @@
 /*
- *  RTEMS RCS Id: paranoia.c,v 1.2 1995/05/31 17:06:09 joel Exp
+ *  $Id$
  *
  *      A C version of Kahan's Floating Point Test "Paranoia"
Index: c/src/tests/samples/paranoia/system.h
===================================================================
--- c/src/tests/samples/paranoia/system.h	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/paranoia/system.h	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -12,5 +12,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  system.h,v 1.2 1995/05/31 17:06:13 joel Exp
+ *  $Id$
  */
 
Index: c/src/tests/samples/ticker/system.h
===================================================================
--- c/src/tests/samples/ticker/system.h	(revision 4b374f36e7172d59d6d8c252973c1ef65637ecbb)
+++ c/src/tests/samples/ticker/system.h	(revision 3235ad9a2cd717df901853ad5220a4aaffae84a9)
@@ -12,5 +12,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  system.h,v 1.2 1995/05/31 17:06:23 joel Exp
+ *  $Id$
  */
 