Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/ChangeLog	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -1,2 +1,14 @@
+2005-04-28	Joel Sherrill <joel@OARcorp.com>
+
+	* libnetworking/kern/kern_sysctl.c, libnetworking/libc/inet_ntop.c,
+	libnetworking/net/if_ppp.c, libnetworking/net/pppcompress.c,
+	libnetworking/net/slcompress.c, libnetworking/netinet/ip_output.c,
+	libnetworking/netinet/udp_usrreq.c, libnetworking/nfs/bootp_subr.c,
+	libnetworking/rtems/rtems_select.c,
+	libnetworking/rtems/rtems_showifstat.c,
+	libnetworking/rtems/rtems_showroute.c,
+	libnetworking/rtems/rtems_syscall.c: Fixed type mismatch and
+	uninitialized variable warnings.
+
 2005-04-28	Joel Sherrill <joel@OARcorp.com>
 
Index: cpukit/libnetworking/kern/kern_sysctl.c
===================================================================
--- cpukit/libnetworking/kern/kern_sysctl.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/kern/kern_sysctl.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -1011,4 +1011,6 @@
 	int error;
 
+	plen = 0; /* RTEMS - to avoid warnings */
+
 	oid[0] = 0;		/* sysctl internal magic */
 	oid[1] = 3;		/* name2oid */
Index: cpukit/libnetworking/libc/inet_ntop.c
===================================================================
--- cpukit/libnetworking/libc/inet_ntop.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/libc/inet_ntop.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -127,5 +127,7 @@
 		words[i / 2] |= (src[i] << ((1 - (i % 2)) << 3));
 	best.base = -1;
+	best.len  = 0;
 	cur.base = -1;
+	cur.len  = 0;
 	for (i = 0; i < (NS_IN6ADDRSZ / NS_INT16SZ); i++) {
 		if (words[i] == 0) {
Index: cpukit/libnetworking/net/if_ppp.c
===================================================================
--- cpukit/libnetworking/net/if_ppp.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/net/if_ppp.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -1170,5 +1170,8 @@
     struct ppp_softc *sc;
 {
-    struct mbuf *m, *mp;
+#ifdef PPP_COMPRESS
+    struct mbuf *mp;
+#endif
+    struct mbuf *m;
     u_char *cp;
     int address, control, protocol;
Index: cpukit/libnetworking/net/pppcompress.c
===================================================================
--- cpukit/libnetworking/net/pppcompress.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/net/pppcompress.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -406,5 +406,6 @@
 {
 	u_char *hdr, *cp;
-	int hlen, vjlen;
+	u_int hlen;
+	int vjlen;
 
 	cp = bufp? *bufp: NULL;
Index: cpukit/libnetworking/net/slcompress.c
===================================================================
--- cpukit/libnetworking/net/slcompress.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/net/slcompress.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -424,5 +424,6 @@
 {
 	u_char *hdr, *cp;
-	int hlen, vjlen;
+	u_int hlen;
+	int vjlen;
 
 	cp = bufp? *bufp: NULL;
Index: cpukit/libnetworking/netinet/ip_output.c
===================================================================
--- cpukit/libnetworking/netinet/ip_output.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/netinet/ip_output.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -101,5 +101,5 @@
 	struct mbuf *m = m0;
 	int hlen = sizeof (struct ip);
-	int len, off, error = 0;
+	int len = 0, off, error = 0;
 	struct sockaddr_in *dst;
 	struct in_ifaddr *ia;
Index: cpukit/libnetworking/netinet/udp_usrreq.c
===================================================================
--- cpukit/libnetworking/netinet/udp_usrreq.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/netinet/udp_usrreq.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -368,4 +368,5 @@
 	int s = 0, error = 0;
 
+	laddr.s_addr = 0;
 	if (control)
 		m_freem(control);		/* XXX */
Index: cpukit/libnetworking/nfs/bootp_subr.c
===================================================================
--- cpukit/libnetworking/nfs/bootp_subr.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/nfs/bootp_subr.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -737,5 +737,5 @@
   int len;
   int code, ncode;
-  char *p;
+  unsigned char *p;
 
   ncode = optbuf[0];
@@ -833,8 +833,8 @@
       if (len>=MAXHOSTNAMELEN)
         panic ("bootpc: hostname >=%d bytes", MAXHOSTNAMELEN);
-      if (sethostname (p, len) < 0)
+      if (sethostname ((char *)p, len) < 0)
         panic("Can't set host name");
       printf("Hostname is %s\n", p);
-      dhcp_hostname = bootp_strdup_realloc(dhcp_hostname,p);
+      dhcp_hostname = bootp_strdup_realloc(dhcp_hostname,(char *)p);
       break;
 
@@ -853,5 +853,5 @@
       if (p[0]) {
         rtems_bsdnet_domain_name = 
-	  bootp_strdup_realloc(rtems_bsdnet_domain_name,p);
+	  bootp_strdup_realloc(rtems_bsdnet_domain_name,(char *)p);
         printf("Domain name is %s\n", rtems_bsdnet_domain_name);
       }
@@ -889,5 +889,5 @@
       if (p[0])
         rtems_bsdnet_bootp_server_name = 
-	  bootp_strdup_realloc(rtems_bsdnet_bootp_server_name,p);
+	  bootp_strdup_realloc(rtems_bsdnet_bootp_server_name,(char *)p);
       break;
 
@@ -896,5 +896,5 @@
       if (p[0])
         rtems_bsdnet_bootp_boot_file_name = 
-	  bootp_strdup_realloc(rtems_bsdnet_bootp_boot_file_name,p);
+	  bootp_strdup_realloc(rtems_bsdnet_bootp_boot_file_name,(char *)p);
       break;
 
@@ -904,5 +904,5 @@
 	   */
 	  if (p[0])
-	  	rtems_bsdnet_bootp_cmdline = strdup(p);
+	  	rtems_bsdnet_bootp_cmdline = strdup((char *)p);
 	  break;
 
@@ -1055,5 +1055,5 @@
   }
   if (dhcpOptionOverload & 1) {
-    processOptions (reply.file, sizeof reply.file);
+    processOptions ((unsigned char *)reply.file, sizeof reply.file);
   }
   else {
@@ -1063,5 +1063,5 @@
   }
   if (dhcpOptionOverload & 2) {
-    processOptions (reply.sname, sizeof reply.sname);
+    processOptions ((unsigned char *)reply.sname, sizeof reply.sname);
   }
   else {
Index: cpukit/libnetworking/rtems/rtems_select.c
===================================================================
--- cpukit/libnetworking/rtems/rtems_select.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/rtems/rtems_select.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -120,5 +120,5 @@
 	fd_set ob[3];
 	int error, timo;
-	int retval;
+	int retval = 0;
 	rtems_id tid;
 	rtems_interval then, now;
Index: cpukit/libnetworking/rtems/rtems_showifstat.c
===================================================================
--- cpukit/libnetworking/rtems/rtems_showifstat.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/rtems/rtems_showifstat.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -60,5 +60,5 @@
 					{
 					struct sockaddr_dl *sdl = (struct sockaddr_dl *)ifa->ifa_addr;
-					unsigned char   *cp = LLADDR(sdl);
+					char   *cp = LLADDR(sdl);
 					int		i;
 
Index: cpukit/libnetworking/rtems/rtems_showroute.c
===================================================================
--- cpukit/libnetworking/rtems/rtems_showroute.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/rtems/rtems_showroute.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -148,5 +148,5 @@
 	int first = 1;
 	int nleft = sdl->sdl_alen;
-	unsigned char *ap = LLADDR (sdl);
+	char *ap = LLADDR (sdl);
 	static const char hextab[16] = "0123456789ABCDEF";
 
Index: cpukit/libnetworking/rtems/rtems_syscall.c
===================================================================
--- cpukit/libnetworking/rtems/rtems_syscall.c	(revision f48f64ab8a7ac3e588d51b3bcb2dc6ee47baccb4)
+++ cpukit/libnetworking/rtems/rtems_syscall.c	(revision 3274c87676e11cfbf1f6d3d554762ecdea47fe79)
@@ -290,5 +290,6 @@
 	struct iovec *iov;
 	struct socket *so;
-	struct mbuf *to, *control;
+	struct mbuf *to;
+	struct mbuf *control = NULL;
 	int i;
 	int len;