Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/ChangeLog	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -1,2 +1,57 @@
+2011-12-04	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
+
+	* libmisc/shell/main_help.c: Make rtems_shell_help_cmd,
+	rtems_shell_help static.
+	* libmisc/shell/main_hexdump.c: Make main_hexdump static.
+	* libmisc/shell/main_id.c: Make rtems_shell_main_id static.
+	* libmisc/shell/main_ifconfig.c: Make rtems_shell_main_ifconfig static.
+	* libmisc/shell/main_ln.c: Make rtems_shell_main_ln static.
+	* libmisc/shell/main_logoff.c: Make rtems_shell_main_logoff static.
+	* libmisc/shell/main_ls.c: Make rtems_shell_main_ls static.
+	* libmisc/shell/main_mallocinfo.c: Include <rtems/libcsupport.h>.
+	Remove private decls of malloc_info,
+	rtems_shell_print_unified_work_area_message.
+	Make rtems_shell_main_malloc_info static.
+	* libmisc/shell/main_medit.c: Remove private decl of
+	rtems_shell_main_mdump.
+	Make rtems_shell_main_medit static.
+	* libmisc/shell/main_mfill.c: Make rtems_shell_main_mfill static.
+	* libmisc/shell/main_mkdir.c: Make rtems_shell_main_mkdir static.
+	* libmisc/shell/main_mknod.c: Make rtems_shell_main_mknod static.
+	* libmisc/shell/main_mmove.c: Remove private decl of
+	rtems_shell_main_mdump.
+	Make rtems_shell_main_mmove static.
+	* libmisc/shell/main_mount.c: Make rtems_shell_main_mount static.
+	* libmisc/shell/main_msdosfmt.c: Make rtems_shell_main_msdos_format
+	static.
+	* libmisc/shell/main_mv.c: Include "internal.h".
+	Make rtems_shell_mv_exit, rtems_shell_main_mv static.
+	Remove private decls of strmode rtems_shell_main_cp, 
+	rtems_shell_main_rm.
+	* libmisc/shell/main_mwdump.c: Make rtems_shell_main_mwdump static.
+	* libmisc/shell/main_netstats.c: Make rtems_shell_main_netstats
+	static.
+	* libmisc/shell/main_perioduse.c: Make rtems_shell_main_perioduse
+	static.
+	* libmisc/shell/main_pwd.c: Make rtems_shell_main_pwd static.
+	* libmisc/shell/main_rm.c: Include "internal.h".
+	Make rtems_shell_rm_exit static.
+	Remove private decl of strmode.
+	* libmisc/shell/main_rmdir.c: Make rtems_shell_main_rmdir static.
+	libmisc/shell/main_route.c: Make rtems_shell_main_route static.
+	* libmisc/shell/main_setenv.c: Make rtems_shell_main_setenv static.
+	* libmisc/shell/main_sleep.c: Make rtems_shell_main_sleep static.
+	* libmisc/shell/main_stackuse.c: Make rtems_shell_main_stackuse static.
+	* libmisc/shell/main_time.c: Make rtems_shell_main_time static.
+	* libmisc/shell/main_tty.c: Make rtems_shell_main_tty static.
+	* libmisc/shell/main_umask.c: Make rtems_shell_main_umask static.
+	* libmisc/shell/main_unmount.c: Make rtems_shell_main_unmount
+	static.
+	* libmisc/shell/main_unsetenv.c: Make rtems_shell_main_unsetenv
+	static.
+	* libmisc/shell/main_whoami.c: Make rtems_shell_main_whoami static.
+	* libmisc/shell/main_wkspaceinfo.c: Make
+	rtems_shell_main_wkspace_info static.
+
 2011-12-04	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: cpukit/libmisc/shell/main_help.c
===================================================================
--- cpukit/libmisc/shell/main_help.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_help.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -28,5 +28,5 @@
  * show the help for one command.
  */
-int rtems_shell_help_cmd(
+static int rtems_shell_help_cmd(
   rtems_shell_cmd_t *shell_cmd
 )
@@ -77,5 +77,5 @@
  * The same with all the commands....
  */
-int rtems_shell_help(
+static int rtems_shell_help(
   int argc,
   char * argv[]
Index: cpukit/libmisc/shell/main_hexdump.c
===================================================================
--- cpukit/libmisc/shell/main_hexdump.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_hexdump.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -80,5 +80,5 @@
 static int main_hexdump(rtems_shell_hexdump_globals* globals, int argc, char *argv[]);
 
-int
+static int
 rtems_shell_main_hexdump(int argc, char *argv[])
 {
Index: cpukit/libmisc/shell/main_id.c
===================================================================
--- cpukit/libmisc/shell/main_id.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_id.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -29,5 +29,5 @@
 #include "internal.h"
 
-int rtems_shell_main_id(
+static int rtems_shell_main_id(
   int   argc __attribute__((unused)),
   char *argv[] __attribute__((unused))
Index: cpukit/libmisc/shell/main_ifconfig.c
===================================================================
--- cpukit/libmisc/shell/main_ifconfig.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_ifconfig.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -30,5 +30,5 @@
 #include "internal.h"
 
-int rtems_shell_main_ifconfig(
+static int rtems_shell_main_ifconfig(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_ln.c
===================================================================
--- cpukit/libmisc/shell/main_ln.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_ln.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -103,6 +103,5 @@
 static int main_ln(rtems_shell_ln_globals* globals, int argc, char *argv[]);
 
-int
-rtems_shell_main_ln(int argc, char *argv[])
+static int rtems_shell_main_ln(int argc, char *argv[])
 {
   rtems_shell_ln_globals  ln_globals;
Index: cpukit/libmisc/shell/main_logoff.c
===================================================================
--- cpukit/libmisc/shell/main_logoff.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_logoff.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -23,5 +23,5 @@
 #include "internal.h"
 
-int rtems_shell_main_logoff(
+static int rtems_shell_main_logoff(
   int   argc __attribute__((unused)),
   char *argv[] __attribute__((unused))
Index: cpukit/libmisc/shell/main_ls.c
===================================================================
--- cpukit/libmisc/shell/main_ls.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_ls.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -133,6 +133,5 @@
 static int main_ls(rtems_shell_ls_globals* globals, int argc, char *argv[]);
 
-int
-rtems_shell_main_ls(int argc, char *argv[])
+static int rtems_shell_main_ls(int argc, char *argv[])
 {
   rtems_shell_ls_globals  ls_globals;
Index: cpukit/libmisc/shell/main_mallocinfo.c
===================================================================
--- cpukit/libmisc/shell/main_mallocinfo.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_mallocinfo.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -20,11 +20,10 @@
 #include <rtems.h>
 #include <rtems/malloc.h>
+#include <rtems/libcsupport.h>
 #include <rtems/shell.h>
+
 #include "internal.h"
 
-extern int malloc_info( region_information_block * );
-extern void rtems_shell_print_unified_work_area_message(void);
-
-int rtems_shell_main_malloc_info(
+static int rtems_shell_main_malloc_info(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_medit.c
===================================================================
--- cpukit/libmisc/shell/main_medit.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_medit.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -26,7 +26,5 @@
 #include "internal.h"
 
-extern int rtems_shell_main_mdump(int, char *);
-
-int rtems_shell_main_medit(
+static int rtems_shell_main_medit(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_mfill.c
===================================================================
--- cpukit/libmisc/shell/main_mfill.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_mfill.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -26,5 +26,5 @@
 #include "internal.h"
 
-int rtems_shell_main_mfill(
+static int rtems_shell_main_mfill(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_mkdir.c
===================================================================
--- cpukit/libmisc/shell/main_mkdir.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_mkdir.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -28,5 +28,5 @@
 #include "internal.h"
 
-int rtems_shell_main_mkdir(
+static int rtems_shell_main_mkdir(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_mknod.c
===================================================================
--- cpukit/libmisc/shell/main_mknod.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_mknod.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -101,5 +101,5 @@
 #include "mknod-pack_dev.c"
 
-int
+static int
 rtems_shell_main_mknod(int argc, char *argv[])
 {
Index: cpukit/libmisc/shell/main_mmove.c
===================================================================
--- cpukit/libmisc/shell/main_mmove.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_mmove.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -26,7 +26,5 @@
 #include "internal.h"
 
-extern int rtems_shell_main_mdump(int, char *);
-
-int rtems_shell_main_mmove(
+static int rtems_shell_main_mmove(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_mount.c
===================================================================
--- cpukit/libmisc/shell/main_mount.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_mount.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -35,5 +35,5 @@
 }
 
-int rtems_shell_main_mount(
+static int rtems_shell_main_mount(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_msdosfmt.c
===================================================================
--- cpukit/libmisc/shell/main_msdosfmt.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_msdosfmt.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -25,5 +25,5 @@
 #include "internal.h"
 
-int rtems_shell_main_msdos_format(
+static int rtems_shell_main_msdos_format(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_mv.c
===================================================================
--- cpukit/libmisc/shell/main_mv.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_mv.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -75,4 +75,6 @@
 #include <unistd.h>
 
+#include "internal.h"
+
 #include "pathnames-mv.h"
 
@@ -101,5 +103,5 @@
 #define exit(ec) rtems_shell_mv_exit(globals, ec)
 
-void
+static void
 rtems_shell_mv_exit (rtems_shell_mv_globals* globals, int code)
 {
@@ -108,14 +110,8 @@
 }
 
-void strmode(mode_t mode, char *p);
 const char *user_from_uid(uid_t uid, int nouser);
 char *group_from_gid(gid_t gid, int nogroup);
 
-static int main_mv(rtems_shell_mv_globals* globals, int argc, char *argv[]);
-
-int rtems_shell_main_cp(int argc, char *argv[]);
-int rtems_shell_main_rm(int argc, char *argv[]);
-
-int
+static int
 rtems_shell_main_mv(int argc, char *argv[])
 {
Index: cpukit/libmisc/shell/main_mwdump.c
===================================================================
--- cpukit/libmisc/shell/main_mwdump.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_mwdump.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -27,5 +27,5 @@
 #include "internal.h"
 
-int rtems_shell_main_mwdump(
+static int rtems_shell_main_mwdump(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_netstats.c
===================================================================
--- cpukit/libmisc/shell/main_netstats.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_netstats.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -40,5 +40,5 @@
 }
 
-int rtems_shell_main_netstats(                       /* command */
+static int rtems_shell_main_netstats(                       /* command */
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_perioduse.c
===================================================================
--- cpukit/libmisc/shell/main_perioduse.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_perioduse.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -22,5 +22,5 @@
 #include "internal.h"
 
-int rtems_shell_main_perioduse(
+static int rtems_shell_main_perioduse(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_pwd.c
===================================================================
--- cpukit/libmisc/shell/main_pwd.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_pwd.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -24,5 +24,5 @@
 #include "internal.h"
 
-int rtems_shell_main_pwd(
+static int rtems_shell_main_pwd(
   int   argc __attribute__((unused)),
   char *argv[] __attribute__((unused))
Index: cpukit/libmisc/shell/main_rm.c
===================================================================
--- cpukit/libmisc/shell/main_rm.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_rm.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -68,4 +68,6 @@
 #include <unistd.h>
 
+#include "internal.h"
+
 #define rindex(s,c)	strrchr(s,c)
 
@@ -95,5 +97,5 @@
 
 #define exit(ec) rtems_shell_rm_exit(globals, ec)
-void
+static void
 rtems_shell_rm_exit (rtems_shell_rm_globals* globals, int code)
 {
@@ -536,5 +538,4 @@
 }
 
-void strmode(mode_t mode, char *p);
 char *fflagstostr(u_long flags);
 const char *user_from_uid(uid_t uid, int nouser);
Index: cpukit/libmisc/shell/main_rmdir.c
===================================================================
--- cpukit/libmisc/shell/main_rmdir.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_rmdir.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -26,5 +26,5 @@
 #include "internal.h"
 
-int rtems_shell_main_rmdir (int argc, char *argv[])
+static int rtems_shell_main_rmdir (int argc, char *argv[])
 {
   char *dir;
Index: cpukit/libmisc/shell/main_route.c
===================================================================
--- cpukit/libmisc/shell/main_route.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_route.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -28,5 +28,5 @@
 #include "internal.h"
 
-int rtems_shell_main_route(
+static int rtems_shell_main_route(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_setenv.c
===================================================================
--- cpukit/libmisc/shell/main_setenv.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_setenv.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -17,5 +17,5 @@
 #include "internal.h"
 
-int rtems_shell_main_setenv(int argc, char *argv[])
+static int rtems_shell_main_setenv(int argc, char *argv[])
 {
   char* env = NULL;
Index: cpukit/libmisc/shell/main_sleep.c
===================================================================
--- cpukit/libmisc/shell/main_sleep.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_sleep.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -24,5 +24,5 @@
 #include "internal.h"
 
-int rtems_shell_main_sleep(
+static int rtems_shell_main_sleep(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_stackuse.c
===================================================================
--- cpukit/libmisc/shell/main_stackuse.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_stackuse.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -23,5 +23,5 @@
 #include "internal.h"
 
-int rtems_shell_main_stackuse(
+static int rtems_shell_main_stackuse(
   int   argc __attribute__((unused)),
   char *argv[] __attribute__((unused))
Index: cpukit/libmisc/shell/main_time.c
===================================================================
--- cpukit/libmisc/shell/main_time.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_time.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -36,5 +36,5 @@
 #endif
 
-int rtems_shell_main_time(
+static int rtems_shell_main_time(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_tty.c
===================================================================
--- cpukit/libmisc/shell/main_tty.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_tty.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -26,5 +26,5 @@
 #include "internal.h"
 
-int rtems_shell_main_tty(
+static int rtems_shell_main_tty(
   int   argc __attribute__((unused)),
   char *argv[] __attribute__((unused))
Index: cpukit/libmisc/shell/main_umask.c
===================================================================
--- cpukit/libmisc/shell/main_umask.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_umask.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -29,5 +29,5 @@
 #include "internal.h"
 
-int rtems_shell_main_umask(
+static int rtems_shell_main_umask(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_unmount.c
===================================================================
--- cpukit/libmisc/shell/main_unmount.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_unmount.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -28,5 +28,5 @@
 #include "internal.h"
 
-int rtems_shell_main_unmount(
+static int rtems_shell_main_unmount(
   int   argc,
   char *argv[]
Index: cpukit/libmisc/shell/main_unsetenv.c
===================================================================
--- cpukit/libmisc/shell/main_unsetenv.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_unsetenv.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -17,5 +17,5 @@
 #include "internal.h"
 
-int rtems_shell_main_unsetenv(int argc, char *argv[])
+static int rtems_shell_main_unsetenv(int argc, char *argv[])
 {
   if (argc != 2)
Index: cpukit/libmisc/shell/main_whoami.c
===================================================================
--- cpukit/libmisc/shell/main_whoami.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_whoami.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -27,5 +27,5 @@
 #include "internal.h"
 
-int rtems_shell_main_whoami(
+static int rtems_shell_main_whoami(
   int   argc __attribute__((unused)),
   char *argv[] __attribute__((unused))
Index: cpukit/libmisc/shell/main_wkspaceinfo.c
===================================================================
--- cpukit/libmisc/shell/main_wkspaceinfo.c	(revision f1d9293ec85476fb00d911ca44b56c18c636a690)
+++ cpukit/libmisc/shell/main_wkspaceinfo.c	(revision 3421e5201f845b479e4881e5468ecf8313728c5a)
@@ -32,5 +32,5 @@
 }
 
-int rtems_shell_main_wkspace_info(
+static int rtems_shell_main_wkspace_info(
   int   argc __attribute__((unused)),
   char *argv[] __attribute__((unused))